﻿Imports System.Threading

Class Library

    Dim mousePosition As Point
    Dim searchThread As Thread

    Public Delegate Sub searchThreadFinished()
    Dim stf As searchThreadFinished
    Dim items As List(Of Media.mediaElement)
    Dim searchNumber As Integer
    Dim displayNumber As Integer

    Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        stf = AddressOf searchFinished
        lvPlaylist.ItemsSource = Controller.instance.Playlist.items
    End Sub

    Private Sub frmLibrary_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles Me.MouseDown
        Dim p = e.GetPosition(Me)

        If p.Y < 24 And e.LeftButton = MouseButtonState.Pressed Then
            Me.DragMove()
        End If
    End Sub


    Private Sub frmLibrary_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles MyBase.MouseDoubleClick
        Dim p = e.GetPosition(Me)

        If p.Y < 24 And e.LeftButton = MouseButtonState.Pressed Then
            Me.Hide()
        End If
    End Sub


    'LiveSearch erwieß sich in den Testläufen als nicht sehr effizient..
    'Private Sub txtSearch_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Input.KeyEventArgs) Handles txtSearch.KeyUp
    '    If txtSearch.Text.Length < 3 Then
    '        Return
    '    End If

    '    If searchThread IsNot Nothing AndAlso searchThread.IsAlive Then
    '        searchThread.Abort()
    '    End If

    '    searchThread = New Thread(AddressOf searchMedia)
    '    searchThread.Start(txtSearch.Text)

    'End Sub

    Sub searchFinished()
        lvSearch.BeginInit()
        lvSearch.ItemsSource = items
        lvSearch.EndInit()
    End Sub

    Sub searchMedia(ByVal q As String)
        searchNumber += 1
        Dim myNumber = searchNumber

        items = Controller.instance().Library.searchMediaFiles(q)

        'Sicherstellen, das zwischenzeitlich nicht schon ein anderes Ergebniss angezeigt wird..
        If searchNumber = myNumber Then
            'Items im GUI Thread aktuallisieren - diese Aktion ist im aktuellen Thread verboten
            lvSearch.Dispatcher.BeginInvoke(stf)
        End If
    End Sub

    Private Sub btnSearch_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnSearch.Click
        items = Controller.instance().Library.searchMediaFiles(txtSearch.Text)
        searchFinished()
    End Sub

    Private Sub lvSearch_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles lvSearch.MouseDoubleClick
        If lvSearch.SelectedItems.Count = 0 Then
            Return
        End If

        addSelectedItems()
        tcContent.SelectedIndex = 0
        tcContent.UpdateLayout()

        lvPlaylist.SelectedItem = lvSearch.SelectedItem
        lvPlaylist.ScrollIntoView(lvSearch.SelectedItem)

        Controller.instance.PlayFile(lvSearch.SelectedItem)
    End Sub

    Sub addSelectedItems()
        lvPlaylist.BeginInit()
        For Each item As Media.mediaElement In lvSearch.SelectedItems
            Controller.instance().addMediaFileToPlaylist(item)
        Next
        lvPlaylist.ItemsSource = Controller.instance().Playlist.items
        lvPlaylist.EndInit()
    End Sub

    Private Sub lvPlaylist_Drop(ByVal sender As Object, ByVal e As System.Windows.DragEventArgs) Handles lvPlaylist.Drop
        Controller.instance().DropFiles(e)

        updatePlaylistSource()
    End Sub

    Sub updatePlaylistSource()
        lvPlaylist.ItemsSource = Controller.instance().Playlist.items
    End Sub


    Private Sub lvPlaylist_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles lvPlaylist.MouseDoubleClick
        Controller.instance().PlayFile(lvPlaylist.SelectedItem)
    End Sub

    Private Sub mnuAdd_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles mnuAdd.Click
        addSelectedItems()
    End Sub

    Private Sub mnuRemove_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles mnuRemove.Click
        lvPlaylist.BeginInit()
        For Each item As Media.mediaElement In lvPlaylist.SelectedItems
            Controller.instance.Playlist.items.Remove(item)
        Next

        lvPlaylist.EndInit()
    End Sub

    Private Sub mnuNew_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles mnuNew.Click
        Controller.instance().Playlist = New Playlist
    End Sub
End Class
